package bmsi.edx;

import java.net.*;
import java.io.*;

public class Remote4978 implements EDXServlet {
  private final static int
    TERMUPDATE = 1,
    TERMWAITKEY = 2;
  private final static int MAXSIZE = 1920;
  private EDXTerm term;
  private Socket sock;
  private DataOutputStream tout;
  private DataInputStream tin;
  
  public Remote4978() {
  }

  public void init() { }

  public void destroy() { }

  public short callJava(EDXServletRequest req) {
    ActiveTCB tcb = req.getTCB();
    term = new EDXTerm(tcb.edx,tcb.gtcba(Edxtcb.TCBCCB)) {

    };
    try {
      ServerSocket svr = new ServerSocket(1234);
      sock = svr.accept();
      try {
	svr.close();
	tout = new DataOutputStream(sock.getOutputStream());
	tin = new DataInputStream(sock.getInputStream());
	// FIXME: authenticate client
	update(0,MAXSIZE);
	for (;;)
	  readcmd();
      }
      finally {
        sock.close();
      }
    }
    catch (IOException x) {
      System.err.println(x);
    }
    finally {
      sock = null;
      term.dispose();
      term = null;
    }
    return -1;
  }

  protected void readcmd() {
  }

  protected void update(int begin,int end) {
    if (end < begin) return;
    int cnt = end - begin + 1;
    byte[] buf = new byte[cnt];
    term.read(begin,buf,0,cnt);
    try {
      tout.writeShort(TERMUPDATE);
      tout.writeShort(begin);
      tout.writeShort(end);
      tout.write(buf);
    }
    catch (IOException x) {
      x.printStackTrace();
    }
  }
}
