package bmsi.edx;

public interface Edxprg {
/** Definition of EDX program header */
  public static final int
    PRGORG = 0,	/* program origin */
    PRGNAM = 2,	/* program name */
    PRGEXT = 10,	/* reserved */
    PRGTCB = 12,	/* address of main TCB */
    PRGSFL = 14,	/* address of local attnlist command */
    PRGEECB = 16,	/* program end ECB address */
    PRGCCB = 18,	/* console control block address */
    PRGSIO = 20,	/* sensor I/O control block pointer */
    PRGOCT = 22,	/* overlay control table */
    PRGDSC = 24,	/* number of data sets (0-9) */
    PRGPGM = 26,	/* nuumber of overlay programs (0-9) */
    PRGHEAD = 28,	/* size of header */
    PRGSFLG = 30,	/* address global attnlist command */
    PRGSTG = 32,	/* address of storage or TCB */
    PRGLOS = 34,	/* length of storage or zero */
    PRGEKEY = 36,	/* program end ECB key */
    PRGATCB = 38,	/* attnlist TCB address */
    PRGPPLP = 40,	/* for spool - prog load point */
    PRGSPL = 42,	/* for spooling use */
    PRGVOL = 44,	/* volumn name load from */
    PRGDSN = 50;	/* data set control blocks */
}
