package bmsi.edx.fs;

public class FSLtr extends FSString {
  private String set;

  public FSLtr(FSPanel pan,int fld,String s) {
    super(pan,fld);
    set = s;
  }

  public boolean validate() {
    char c = getValue();
    if (set.indexOf(c) < 0) {
      c = Character.toUpperCase(c);
      if (set.indexOf(c) < 0) return false;
      super.setString(String.valueOf(c));
    }
    return true;
  }

  public void setString(String s) {
    super.setString(s);
    setValid(set.indexOf(getValue()) >= 0);
  }

  public void paint() {
    if (set.indexOf(getValue()) < 0)
      setValue(set.charAt(0));
  }

  public void setValue(char c) {
    if (set.indexOf(c) < 0)
      throw new IllegalArgumentException("Letter not valid");
    setValid(true);
    super.setString(String.valueOf(c));
  }

  public char getValue() {
    char c = getString().charAt(0);
    if (set.indexOf(c) < 0)
      c = Character.toUpperCase(c);
    return c;
  }

}
