 ENTRY PLINE,QPRINT,LPRINT,PAGESIZE,LINESIZE
 EXTRN LOADJAVA,JAVA,UNBIND
*-------------------------------------------------------------*
*  THIS SUBROUTINE PROVIDES SINGLE BUFFER OVERLAPPED PRINTING *
*  ON ANY TERMINAL.					      *
*							      *
*     CALL QPRINT,(TXT),(IOCB),(BUSY) ** ASSIGN TXT AS USER   *
*	 BUFFER.  IF NO DEVICE ATTACHED, ATTACH IOCB. BRANCH  *
*	 TO BUSY IF NONZERO AND NOT AVAILABLE, ELSE WAIT.     *
*							      *
*     CALL LPRINT,FORMS		      ** PRINT CURRENT USER   *
*	 BUFFER.  IF FORMS > 0, MOVE TO SPECIFIED LINE BEFORE *
*	 PRINTING.  (LINE NUMBERING BEGINS WITH ONE) IF FORMS *
*	 < 0, SKIP LINES AFTER PRINTING.  BUFFER IS CLEARED   *
*	 AFTER EACH CALL.  IF FORMS = 0, DETACH DEVICE.       *
*							      *
*     PLINE IS THE LINE ABOUT TO BE PRINTED. IF ZERO, DEVICE  *
*	 IS NOT ATTACHED.				      *
*-------------------------------------------------------------*
* $Log: lprt.e,v $
* Revision 1.2  2000/05/19 21:50:35  stuart
* migrate most code to EDXLPrint.java
*
*
* (CHANGED 2/13/86)
* DELETE KBDTASK REQUIREMENT FOR TERMINALS WITH ATTN=NO
*
#PRTLIN  VERSION '$Id: lprt.e,v 1.2 2000/05/19 21:50:35 stuart Exp $',TIME=YES,TYPE=TEXT,LENGTH=132
* $Protect:
LPRT	 TEXT 'bmsi.edx.EDXLPrint' $
JID	 DATA F'-1'
PAGESIZE DATA F'0'
PLINE	 DATA F'0'
*
 SUBROUT QPRINT,#TEXT,#IOCB,#BUSY
	 IF (PLINE,EQ,0)       ** IF DEVICE NOT ATTACHED
	   IF (#IOCB,NE,0)
	     CALL LOADJAVA,JID,(LPRT)
	     CALL GRABPTR
	     CALL JAVA,JID,(QPRINT),6
	     TCBPUT TERM,$TCBCCB
	     TCBGET PAGESIZE,$TCBCO2
	     MOVE PLINE,1
	   ENDIF
	 ENDIF
	 MOVE #IOCB,0,2
	 RETURN
*
 SUBROUT LPRINT,#FC
         IF PLINE,NE,0
	   TCBPUT PRTR,$TCBCCB
	   CALL JAVA,JID,(LPRINT),2
	   TCBGET PLINE,$TCBCO2
	   IF (PLINE,EQ,0)
	     DEQT
	     CALL UNBIND,JID
	     RETURN
	   ENDIF
	   TCBPUT TERM,$TCBCCB
	 ENDIF
	 RETURN
*
 SUBROUT GRABPTR
	 MOVE PRTIOCB,#IOCB
	 TCBGET TERM,$TCBCCB
	 IF (#BUSY,NE,0)
	   ENQT *,P1=PRTIOCB,BUSY=#QUIT
	 ELSE
	   MOVE IOCB2,PRTIOCB
	   ENQT *,P1=IOCB2
	 ENDIF
	 TCBGET PRTR,$TCBCCB
	 MOVE #1,0,P2=PRTR
	 MOVE PAGESIZE+1,($CCBBOTM,#1),BYTE,FKEY=0
	 MOVE LINESIZE+1,($CCBTOPM,#1),BYTE,FKEY=0
	 SUB PAGESIZE,0,P2=LINESIZE
	 ADD PAGESIZE,1
	 MOVE LINESIZE+1,($CCBLMAX,#1),BYTE,FKEY=0
	 RETURN
*
#QUIT	 GOTO (#BUSY)
*
TERM	 DATA F'0'
	 PRINT OFF
	 COPY CCBEQU
	 END
